Require Import connectives.
Require Import logic.
Definition reflexive : forall (A:Type), (A -> A -> Prop) -> Prop := fun (A:Type) => fun (R:(A -> A -> Prop)) => forall (x:A), R x x.
Definition RC : forall (A:Type), (A -> A -> Prop) -> A -> A -> Prop := fun (A:Type) => fun (R:(A -> A -> Prop)) => fun (x:A) => fun (y:A) => connectives.Or (R x y) (logic.eq (A) x y).
Definition RC_reflexive : forall A, forall (R:(A -> A -> Prop)), reflexive (A) (RC (A) R) := fun (A:Type) => fun (R:A -> A -> Prop) => fun (x:A) => (((connectives.or_intror) (R x x)) (logic.eq (A) x x)) (((logic.refl) (A)) (x)).
Definition injective : forall (A:Type), forall (B:Type), (A -> B) -> Prop := fun (A:Type) => fun (B:Type) => fun (f:(A -> B)) => forall (x:A), forall (y:A), (logic.eq (B) (f x) (f y)) -> logic.eq (A) x y.
